package Controller

import (
	cmap "github.com/orcaman/concurrent-map"
	"src/Common/Unit"
	"src/Config"
	"src/Model/Wasu"
	"time"
)

type WasuChecker struct {
	Config *Config.Config
	queue cmap.ConcurrentMap
}

func (this *WasuChecker) Start() {
	this.queue =cmap.New()
	//定时遍历SP，检查SP是否启动
	go func() {
	START:
		s, ok := this.Config.Sys.Get("config_sp_check_seconds")
		if ok {
			this.check()
			n := Unit.Time2Seconds(s.(string))+10
			time.Sleep(time.Duration(n) * time.Second)
		}
		goto START
	}()
}

func (this *WasuChecker) check() {
	for _, tmp := range this.Config.Sps.Items() {
		sp := tmp.(map[string]interface{})
		spid:= sp["id"].(string);
		if !this.queue.Has(spid) {
			this.queue.Set(spid, "running")
			spModel := new(Wasu.SpModel)
			spModel.Config = this.Config
			spModel.Spid = spid
			//st, _ := DateTime.Parse("YYYY-MM-DD hh:mm:ss", sp["push_offset"].(string))
			//spModel.StartTime = DateTime.Format("YYYYMMDDhhmmss", st)
			go spModel.Start()
		}
	}
}


