package main

import (
	log "github.com/sirupsen/logrus"
	"runtime"
	"src/Config"
	. "src/Controller"
)

func main() {
	log.SetLevel(log.DebugLevel)

	config := Config.GetInstance()
	err1 := config.InitSysConfig()
	err2 := config.InitSpsConfig()
	//初始化成功
	if err1 == nil && err2 == nil {
		configCHK := new(ConfigChecker)
		configCHK.Start()

		//华数媒资拉取
		wasuCHK := new (WasuChecker)
		wasuCHK.Config=config
		wasuCHK.Start()

		//合作方媒资推送
		spCHK :=new(SpChecker)
		spCHK.Config=config
		spCHK.Start()
	} else {
		log.Errorln("初始化系统配置错误：", err1)
		log.Errorln("初始化合作方配置错误：", err2)
	}

	runtime.Goexit()
}
