<?php
/**
 * Created by PhpStorm.
 * User: wuxiande
 * Date: 2019/7/17
 * Time: 15:13
 */


require'./App/Predis/autoload.php';

class MonitorAction extends Action
{

    public function devices()
    {

        $this->assign('SYSTEM_INFO',C('SYSTEM_INFO'));

        $limitRtimeout=60;
        $limitCpu=0.9;
        $limitMem=0.9;

        $sql = "SELECT id,code,name,ip"
            ." FROM sh_hotel_device"
            ." WHERE status<2 "
            ." ORDER BY id ASC;";
        $Devices = D("")->query($sql);
        $values="";
        foreach ($Devices as $device){
            $values.="\"".$device["code"]."\",";
        }
        $values=rtrim($values,",");

//        var_dump($values);exit;

        $redisConfig=C('RedisConfig');
        $server = $redisConfig["server"];
        $options = $redisConfig["options"];
        $redis = new Predis\Client($server,$options);
        $script_D = $this->makeLuaScript("LDR",$values);
        $script_S = $this->makeLuaScript("LSR",$values);
        $mDeviceData = $redis->eval($script_D,0);
        $mServiceData = $redis->eval($script_S,0);

//        var_dump($mDeviceData);
//        echo "<br/>";
//        var_dump($mServiceData);
//        exit;


        foreach ($Devices as $k=>&$device){

                $mDinfo=json_decode($mDeviceData[$k]); //设备监控信息
                $mSinfo=json_decode($mServiceData[$k]); //设备监控信息

                $device["status"] = 0; //0正常,1服务汇报超时,2设备汇报超时,3,设备超负载,其他未知
                $device["reason"] = "正常";

                $mTime = $mSinfo->t;
                if ($mTime+$limitRtimeout < time()){
                    $device["status"] = 1; //0正常,1服务汇报超时,2设备汇报超时,3,设备超负载,其他未知
                    $device["reason"] = "服务汇报超时";
                }
                $device["lst"]= date( "Y-m-d H:i:s",$mTime) ; //汇报时间
                $mTime = $mDinfo->t;
                if ($mTime+$limitRtimeout < time()){
                    $device["status"] = 2;
                    $device["reason"] = "设备汇报超时";
                }
                //判断负载
                foreach ($mDinfo->o as $item){
                    if ($item[0]=="avg15" && $item[1]>=$limitCpu){
                        $device["status"]=3;
                        $device["reason"]="CPU超负载";
                    }
                    if ($item[0]=="mem" && $item[1]>=$limitMem){
                        $device["status"]=3;
                        $device["reason"]="内存超负载";
                    }
                }

        }


        echo json_encode($Devices);
        exit;

    }

    function makeLuaScript($key,$value){
        $script ="local d = redis.call(\"hmget\",\"$key\", $value)"
        ." local r = {}"
        ." for k,v in ipairs(d)"
        ." do"
            ." if v then r[k] = cjson.encode(cmsgpack.unpack(v)) else r[k]=cjson.encode(nil) end"
        ." end"
        ." return r";

    //    echo $script;exit;
        return $script;
    }

    public function details(){
        $id = $_GET["id"];
        $this->assign('SYSTEM_INFO',C('SYSTEM_INFO'));

        $limitRtimeout=60;
        $limitCpu=0.9;
        $limitMem=0.9;

        $sql = "SELECT id,code,name,ip"
            ." FROM sh_hotel_device"
            ." WHERE id=$id;";

//        echo $sql;
        $Devices = D("")->query($sql);
        $values="";
        foreach ($Devices as $device){
            $values.="\"".$device["code"]."\",";
        }
        $values=rtrim($values,",");

//        var_dump($values);exit;
        if (!empty($Devices)) {
            $redisConfig = C('RedisConfig');
            $server = $redisConfig["server"];
            $options = $redisConfig["options"];
            $redis = new Predis\Client($server, $options);
            $script_D = $this->makeLuaScript("LDR", $values);
            $script_S = $this->makeLuaScript("LSR", $values);
            $mDeviceData = $redis->eval($script_D, 0);
            $mServiceData = $redis->eval($script_S, 0);

//        var_dump($mDeviceData);
//        echo "<br/>";
//        var_dump($mServiceData);
//        exit;
//        str_replace("world","Shanghai","Hello world!");

            foreach ($Devices as $k => &$device) {
                $mDinfo=json_decode($mDeviceData[$k]); //设备监控信息
                $mSinfo=json_decode($mServiceData[$k]); //设备监控信息

                $device["服务汇报时间"] = date( "Y-m-d H:i:s",$mSinfo->t);
                $device["设备监控信息"] = $mDinfo; //设备监控信息
                $device["服务监控信息"] = $mSinfo; //设备监控信息

            }


            echo json_encode($Devices[0]);
        }else{
            $e["错误"] = "找不到该设备!";
            echo json_encode($e);
        }
        exit;
    }

}